const EXPORTED_SYMBOLS = ["YaFTabIMStore"];

var YaFTabIMStore = {
    RESOURCE_PATH_PREFIX: "resource://yandex-profile-data/ftab-data/backgrounds/",
    USER_FILES_PREFIX: "user-",
    
    PERMS_FILE: parseInt("0644", 8),
    
    get nsIYa() {
      delete this.nsIYa;
      return this.nsIYa = Components.classes["@yandex.ru/yasearch;1"]
                                    .getService(Components.interfaces.nsIYaSearch)
                                    .wrappedJSObject;
    },
    
    get nsIYaFTab() {
      delete this.nsIYaFTab;
      return this.nsIYaFTab = this.nsIYa.yaFTab;
    },
    getNewFile: function YaFTabIMStore_getNewFile(directory, filename) {
        let tmpFile = directory.clone();
        tmpFile.append(filename);
        tmpFile.createUnique(tmpFile.NORMAL_FILE_TYPE, this.PERMS_FILE);
        tmpFile.remove(false);
        return tmpFile;
    },
    getStoreDir: function YaFTabIMStore_getStoreDir() {
        return this.nsIYaFTab.getProfileDirectory("backgrounds");
    },
    existsStoreDir: function YaFTabIMStore_existsStoreDir() {
        return this.nsIYaFTab.getProfileDirectory("backgrounds", true).exists();
    },
    copyFile: function YaFTabIMStore_copyFile(file) {
        let store = this.getStoreDir();
        
        if (!store)
            return;
        
        let newFile = this.getNewFile(store, this.USER_FILES_PREFIX + file.leafName);
        
        file.copyTo(store, newFile.leafName);
        file.permissions = this.PERMS_FILE;
        
        return this.getResourcePathForFileName(newFile.leafName);
    },
    
    removeFile: function YaFTabIMStore_removeFile(aFilePath) {
        let leafName = aFilePath.replace(this.RESOURCE_PATH_PREFIX, "");
        
        if (leafName == aFilePath)
            return;
            
        let file = this.getStoreDir();
        file.append(leafName);
        
        return this.nsIYa.removeFile(file);
    },
    
    getResourcePathForFileName: function YaFTabIMStore_getResourcePathForFileName(aFileLeafName) {
        return this.RESOURCE_PATH_PREFIX + aFileLeafName;
    }
};
